gui/config/routes.rb
Smr::Application.routes.draw do

  root :to => 'asset#index'

  resources :asset
  get  '/asset/show_portfolio/:id_portfolio', :to=>'asset#index', :as=>'show_portfolio'
  post '/asset/show_portfolio/',              :to=>'asset#index', :as=>'show_portfolio_post'

  resources :order
  resources :report
  resources :cashflow
  resources :watchlist
  resources :figures
  resources :quoterecords
  resources :quoterecord_threshold
  resources :quoterecord_rules

  post "set_session_params" => "application#set_session_params"

  get 'logout' => 'sessions#destroy', :as => 'logout'
  get 'login' => 'sessions#new', :as => 'login'
  resources :sessions
  resources :password_reset

  resources :position
  post 'execute_order', to: 'position#execute_order'
  post 'cancel_order', to: 'position#cancel_order'
  post 'patch_position', to: 'position#patch'
  get 'close', to: 'position#close'

  get '/workdesk/add',      :to=>'workdesk#add',  :as=>'workdesk_add'
  get '/workdesk/:id/drop', :to=>'workdesk#drop', :as=>'workdesk_drop'
  resources :workdesk

  resources :portrait
  get '/portrait/organization/:id', :to=>'portrait#show_organization', :as=>'portrait_organization'
  get '/portrait/security/:id',     :to=>'portrait#show_security',     :as=>'portrait_security'

  resources :cashposition
  get '/cashposition/:id/settle', :to=>'cashposition#settle', :as=>'settle_cashposition'

  resources :documents
  get 'download' => 'documents#download'
  get 'delete_document' => 'documents#delete_document'

  resources :blog
  get 'blog' => 'blog#index'

  get 'objects' => 'objects#index'
  namespace 'objects' do
      resources :organization, :security, :bookmark, :portfolio, :figurevar, :user
      post 'patch_portfolio', to: 'portfolio#patch'
  end
  get '/objects/security/:id/delete', :to=>'objects/security#destroy', :as=>'delete_security'
  get '/objects/export/securities',   :to=>'objects/security#export',  :as=>'export_securities'
  get '/objects/bookmark/:id/delete', :to=>'objects/bookmark#destroy', :as=>'delete_bookmark'

  resources :doc, :only=>:get_file
  get "/doc/:file_or_folder", :controller=>:documentation, :action=>:get_file, :file_or_folder=>/.*/
end

gui/app/controllers/cashposition_controller.rb
#
# This file is part of SMR.
#
# SMR is free software: you can redistribute it and/or modify it under the
# terms of the GNU General Public License as published by the Free Software
# Foundation, either version 3 of the License, or (at your option) any later
# version.
#
# SMR is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along with
# SMR.  If not, see <http://www.gnu.org/licenses/>.
#
require 'uploaded_file'

##
# Handles a Cash Position
#
# From the model perspective its the same as a Position holding a security.
# From the usage point of view its completly different: a cash position looks
# and behaves like a bank deposit.
class CashpositionController < ApplicationController

    ##
    # Show Cash Deposit at current browse date.
    def show
        @position = Smr::AssetPosition.new(params[:id].to_i, current_user.id, smr_browse_date)

        smr_menu_addsubitem('assets',
            {
                '+ booking'=>'%s?id=%i' % [new_cashposition_path, params[:id]],
                '- settle'=>settle_cashposition_path(params[:id])
            }
        ) unless @position.is_closed?

        redirect_to root_path if not @position.is_cash_position?

        @page = smr_page
        @documents, @total_pages = smr_paginate(@page, Smr::UploadedFiles.new(current_user.id, :id_position=>@position.id))
    end

    ##
    # Prepare a cash booking Transaction.
    def new
        @booking = Smr::Transaction.new(Position.find(params[:id]), current_user)
        show
        render :show
    end

    ##
    # Creates a Transaction to book cash on the Position.
    def create
        bp = booking_params
        valuta = Time.parse(bp[:date])
        cp = Smr::Transaction.find_cashposition(  # find cashposition in portfolio at date of valuta
           Position.find(bp[:id_cashposition]).id_portfolio,
           current_user.id,
           valuta
        )

        booking = Smr::Transaction.new(cp, current_user, :issue_time=>valuta, :type=>bp[:type].to_sym)
        booking.set_comment(bp[:comment])
        booking.book(bp[:amount].to_f, :time=>valuta)

        # handle document
        if params[:document] then
            doc = Smr::UploadedFile.store(current_user.id, params[:document])
            doc.assign(:order=>booking.order.id)
        end

        redirect_to cashposition_path(:id=>bp[:id_cashposition]), :notice=>booking.error
    end

    ##
    # Settle cash position
    # - the cashposition is closed and its balance is booked into
    #   a cashposition for the next year
    # - once settled its not possible to book new transactions into
    #   the portfolio that year. Read: "accounting has closed its books".
    def settle
        p = Smr::AssetPosition.new(params[:id].to_i, current_user.id, smr_browse_date)
        p.settle
        redirect_to :back
    end

 protected

    ##
    # Internal helper defining which parameters to accept for a booking.
    def booking_params
      params.require(:booking).permit(
        :amount, :date, :comment, :id_cashposition, :type
      )
    end
end

gui/app/views/cashposition/_booking_form.html.erb
<%= form_tag({:controller=>'cashposition', :action=>'create'}, :multipart=>true) do %>
 <fieldset id='cashbooking'>
  <legend>New Cash Booking</legend>
    <%= hidden_field_tag 'booking[id_cashposition]', transaction.cash_position.id %>
    <p>
    <%= number_field_tag 'booking[amount]', number_with_precision(0, :precision=>2), {:step=>0.01} %>
    <%= label_tag 'booking[amount]', 'Amount of Money' %>
    </p>
    <p>
    <%= date_field_tag 'booking[date]', smr_humanize(@booking.order.time_issued) %>
    <%= label_tag 'booking[date]', 'Date of Valuta' %>
    </p>
    <%= text_area_tag 'booking[comment]', nil, :placeholder=>'Comment' %>

    <hr/>
    <%= label_tag :document, 'Clearing Document' %>: <%= file_field_tag :document %>
    <hr/>

    <br/>
    <%= button_tag 'Make Cash Booking', {:name=>'booking[type]', :value=>:cash_booking} %>
    <%= button_tag 'Make Salary Booking', {:name=>'booking[type]', :value=>:salary_booking} %>
 </fieldset>
<% end %>

gui/app/views/cashposition/show.html.erb
<h1>Cash Deposit at <%=@position.portfolio%>: <%=@position.comment%> </h1>

<h2>Balance</h2>


<% if @position.is_closed? and not @position.is_viewed_before_closure? %>
    <p>Accounting for <%=@position.time_closed.year - 1%> has been settled. Its balance has been carried over into <%=@position.time_closed.year %>.</p>
<% elsif @position.is_new? %>
    <p>Accounting for this period has been opened. You may add bookings manually or execute orders.</p>
<% else %>
    <p>
      <% if @position.is_closed? %>
          Accounting has been settled at end of period. Shown is its state at browse date.
      <% else %>
          Accounting for this Period is open and ongoing.
      <% end %>
    </p>
    <% if @booking %><%= render :partial=>'cashposition/booking_form', locals: {:transaction=>@booking} %><% end %>
    <div id='deposit_balance'>
      <ul>
        <li class="<%= if @position.invested<0 then 'loss' else 'profit' end%>">
            Current Balance: <em><%= smr_humanize(@position.invested, :scale=>2) %></em>
        </li>
      </ul>
    </div>
<% end %>


<% if not @position.is_new? %>
<h2>Transaction Log</h2>
<table id='transaction_log'>
    <thead>
    <tr>
        <th></th>
        <th>Details</th>
        <th>Debit</th>
        <th>Credit</th>
    </tr>
    </thead>
    <tbody>
<% @position.revisions.reverse.each do |pr| %>
    <% next if pr.id_order==0  # skip old-style first emtpy revision %>
    <tr class="separaterows">
        <td><%=smr_humanize(pr.time_created)%></td>
        <td>
            <%=pr.Order%>
            <% if pr.Order.triggered_by_order %>
                <%= link_to 'Order #%i'% pr.Order.triggered_by_order, order_path(:id=>pr.Order.triggered_by_order) %>
            <%end%>
            <% if not pr.Order.comment.blank? %><span class="comment_text"><%=pr.Order.comment%></span><% end %>
            <%= if pr.Order.has_document? then link_to 'doc', {:id=>pr.Order.id_document, :controller=>'documents', :action=>'download'} end %>
        </td>
        <td><%=smr_humanize(pr.Order.volume * -1) if pr.Order.type=='sale' %></td>
        <td><%=smr_humanize(pr.Order.volume) if pr.Order.type=='buy' %></td>
    </tr>
<% end %>
    </tbody>
</table>
<% end %>

<h2>Documents <em>Uploaded or assigned to this position.</em></h2>
<% if not @documents.empty? %>
<%=
render :partial=>'documents/filelist',
    locals: {
        :page=>@page, :total_pages=>@total_pages,
        :link_path=>documents_path,
        :collection=>@documents
    }
%>
<% end %>

<%= render :partial=>'documents/upload_form', locals: { :id=>@position.id, :assign_to=>:position } %>